/* $Header: /src/carson/nistnet/RCS/kincludes.h,v 1.3 1998/03/02 18:40:51 carson Exp $ */
/* Kernel includes
 *
 * To clean up the effort to make the code work with glibc, the
 * list of includes used is being centralized.
 */

#ifndef _K_INCLUDES_H
#define _K_INCLUDES_H

/* Kernel code can't currently be compiled with most any of the glibc
 * headers!  Glibc is for user level code!
 */
#include <linux/types.h>
#include <linux/version.h>
#include <linux/config.h>
#include <net/checksum.h>

#ifndef KERNEL_VERSION
/* Older Linux kernels did this "geeky-macho" thing of making you
 * figure out the version codes yourself....
 */
#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,0)
typedef __u32 u_int32_t;
typedef __u16 u_int16_t;
typedef __u8 u_int8_t;
#define copy_to_user_ret(to, from, n, retval)	memcpy_tofs(to, from, n)
#define copy_from_user_ret(to, from, n, retval)	memcpy_fromfs(to, from, n)
#else
#include <asm/uaccess.h>
#endif

#define bzero(addr, len)	memset(addr, 0, len)
#define bcopy(src, dest, len)	memcpy(dest, src, len)
#define bcmp(s1, s2, len)	memcmp(s1, s2, len)
/*#include <sys/bitypes.h>*/

#include <asm/irq.h>
#include <asm/segment.h>
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/major.h>
#include <linux/malloc.h>
#include <linux/mm.h>
#include <linux/netdevice.h>
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)
#include <linux/inetdevice.h>
#include <linux/poll.h>
#endif

#include <linux/errno.h>
#include <linux/param.h>
#include <linux/timex.h>

#include <asm/io.h>

#include <linux/in.h>
#include <linux/socket.h>

/* Local header files */
#include "linux/fast_timer.h"
#include "nistnet.h"
#ifndef _NISTNET_TABLE_H
#include "nistnet_table.h"
#endif

#endif
